package business;

import java.util.Vector;
import java.io.Serializable;


public class EventSoundHandler implements Serializable
{
    private String sEventName;
    private String sSoundVariable;
    private String sTime;
    private int iNote;
    private boolean bStatus;
    private String sDefaultSoundVariable;
    private String sDefaultTime;
    private int iDefaultNote;


    public EventSoundHandler()
    {
        iNote=0;
        bStatus = false;
    }

    public EventSoundHandler(String sEventName, String sSoundVariable, String sTime, int iNote)
    {
        this.sEventName = sEventName;
        this.sSoundVariable = this.sDefaultSoundVariable = sSoundVariable;
        this.sTime  = this.sDefaultTime = sTime;
        this.iNote = this.iDefaultNote= iNote;
        this.bStatus = true;
    }

    public String getEventName()
    {
        return sEventName;
    }

    public void setEventName(String sEventName)
    {
        this.sEventName = sEventName;
    }

    public String getSoundVariable()
    {
        return sSoundVariable;
    }

    public void setSoundVariable(String sSoundVariable)
    {
        this.sSoundVariable = sSoundVariable;
    }

    public String getTime()
    {
        return sTime;
    }

    public void setTime(String sTime)
    {
        this.sTime = sTime;
    }

    public int getNote()
    {
        return iNote;
    }

    public void setNote(int iNote)
    {
        this.iNote = iNote;
    }

    public boolean isStatus()
    {
        return bStatus;
    }

    public void setStatus(boolean bStatus)
    {
        this.bStatus = bStatus;
    }

    public void changeMapping(Vector vSoundProperties)
    {

        if(vSoundProperties.get(0) != null)
        {
            sSoundVariable = (String)vSoundProperties.get(0);
            System.out.println("sSoundVariable : " + sSoundVariable);
        }

        if(vSoundProperties.get(1) != null)
        {
            iNote = ((Integer)vSoundProperties.get(1)).intValue();
            System.out.println("iNote : " + iNote);
        }

        if(vSoundProperties.get(2) != null)
        {
            sTime = (String)vSoundProperties.get(2);
            System.out.println("sTime : " + sTime);
        }

        if(vSoundProperties.get(3) != null)
        {
            bStatus = ((Boolean)vSoundProperties.get(3)).booleanValue();
            System.out.println("bStatus : " + bStatus);
        }
    }



    public Vector getSoundProperties()
    {
        Vector vSoundProperties = new Vector();

        vSoundProperties.add(sSoundVariable);
        vSoundProperties.add(new Integer(iNote));
        vSoundProperties.add(sTime);
        vSoundProperties.add(new Boolean(bStatus));

        return vSoundProperties;
    }

    public String getDefaultSoundVariable()
    {
        return sDefaultSoundVariable;
    }


    public String getDefaultTime()
    {
        return sDefaultTime;
    }


    public int getDefaultNote()
    {
        return iDefaultNote;
    }

}
