package business;


import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.io.Serializable;


public class ProgramHandler implements Serializable
{
    private String sProgramName;
    private Hashtable htEventSound;


    public ProgramHandler()
    {
        htEventSound = new Hashtable();

    }

    public ProgramHandler(String sProgramName)
    {
        this.sProgramName = sProgramName;
    }

    public ProgramHandler(String sProgramName,Hashtable htEventSound)
    {
        this.sProgramName = sProgramName;
        this.htEventSound=htEventSound;
    }


    public String getProgramName()
    {
        return sProgramName;
    }

    public void setProgramName(String sProgramName)
    {
        this.sProgramName = sProgramName;
    }

    public void addEventSoundHandlers(Hashtable htEventSoundMappings)
    {

        Enumeration objKey = htEventSoundMappings.keys();

        while(objKey.hasMoreElements()==true)
        {
                 EventSoundMapping objESM = (EventSoundMapping)htEventSoundMappings.get(objKey.nextElement());
                 EventSoundHandler objESH = new EventSoundHandler(objESM.getEventName(),objESM.getSoundVariable(),objESM.getTime(),objESM.getNote());

                 htEventSound.put(objESM.getEventName(), objESH);
        }
    }


   /* public void addEventSoundHandler(EventSoundHandler objESH)
    {
        htEventSound.add(objESH);

    }*/

    /*public void removeEventSoundHandler(EventSoundHandler objESH)
    {
        vEventSound.remove(objESH);
    } */

    /**
     * This function is used to search the vector to return appropriate Event-Sound Handler
     * @param sEventName
     * @return EventSoundHandler
     */
    private EventSoundHandler getEventSoundHandler(String sEventName)
    {
        return (EventSoundHandler)htEventSound.get(sEventName);
    }

    public void changeEventSoundMapping(String sEventName, Vector vSoundProperties)
    {
        EventSoundHandler objESH = getEventSoundHandler(sEventName);

        if(objESH != null)
        {
            objESH.changeMapping(vSoundProperties);
        }
    }

    public Vector getSoundProperties(String sEventName)
    {
        EventSoundHandler objESH = getEventSoundHandler(sEventName);
            System.out.println("Events Size :  "+ htEventSound.size());
        if(objESH != null)
        {

            return (objESH.getSoundProperties());
        }

        return null;
    }

    public Vector getEvents()
    {
        /*
        Format of the Vector is

        EventName    0
        SoundVariable  1
        Time 2
        Note  3
        Default Sound Variable 4
        Default Time 5
        Default Note 6
        Status 7
        */
        Vector vESHArray = new Vector();


        Enumeration objEnum = htEventSound.keys();

        while(objEnum.hasMoreElements())
        {
            EventSoundHandler objESH =(EventSoundHandler) htEventSound.get(objEnum.nextElement());
            Vector vESH = new Vector();
            vESH.add(objESH.getEventName());
            //System.out.println("Event Name in ProgramHandler.getEvents(): " + objESH.getEventName());
            vESH.add(objESH.getSoundVariable());
            //System.out.println("Sound Variable Name in ProgramHandler.getSoundVariable(): " + objESH.getSoundVariable());
            vESH.add(objESH.getTime());
            vESH.add(new Integer(objESH.getNote()));
            //System.out.println("");
            vESH.add(objESH.getDefaultSoundVariable());
            vESH.add(objESH.getDefaultTime());
            vESH.add(new Integer(objESH.getDefaultNote()));
            vESH.add(new Boolean(objESH.isStatus()));

            vESHArray.add(vESH);
        }
        return vESHArray;
    }

    public void updateProgramMapping(Vector vEventName, Vector vSoundProperties)
    {
        for(int iLoop =0; iLoop < vEventName.size(); iLoop++)
        {
            EventSoundHandler objESH = getEventSoundHandler((String)vEventName.get(iLoop));
            Vector vSoundProp = (Vector) vSoundProperties.get(iLoop);

            if(objESH != null)
            {
                objESH.changeMapping(vSoundProp);
            }
        }
    }
}

