package business;

import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;

import access.RegisteredProgramsDB;



public class RegisterManager extends Thread
{
    private Hashtable htProgramHandlers;
    private boolean bStatus=false;



   public RegisterManager()
    {
        htProgramHandlers = new Hashtable();

        RegisteredProgramsDB objRPDB = new RegisteredProgramsDB();
        Vector vProgramNames = objRPDB.retrieveProgramNames();

        if(vProgramNames != null )
        {

            for(int iLoop=0; iLoop<vProgramNames.size();iLoop++)
            {
                String sProgramName = (String)vProgramNames.get(iLoop);
                //System.out.println("PNAME= "+sProgramName+" RETRIEVE DB ="+objRPDB.retrieveProgramHandler(sProgramName));
                htProgramHandlers.put(sProgramName,objRPDB.retrieveProgramHandler(sProgramName));
            }
        }
    }


/*    private void addProgramHandler(String sProgramName)
    {
        ProgramHandler objPH = new ProgramHandler(sProgramName);
        objPH.addEventSoundHandlers(htEventSoundMapping);
        htProgramHandlers.put(sProgramName,objPH);

        RegisteredProgramsDB objRPDB = new RegisteredProgramsDB();
        objRPDB.storeProgramNames(htProgramHandlers);

        objRPDB.storeProgramHandler(sProgramName,objPH);
    }

    private void removeProgramHandler(String sProgramName)
    {
        htProgramHandlers.remove(sProgramName);

        RegisteredProgramsDB objRPDB = new RegisteredProgramsDB();
        objRPDB.storeProgramNames(htProgramHandlers);

        objRPDB.removeProgramHandler(sProgramName);
    }*/

    public Vector getProgramNames()
    {
        Vector vProgramNames = new Vector();

        Enumeration objKey = htProgramHandlers.keys();

        while(objKey.hasMoreElements()==true)
        {
                vProgramNames.add(objKey.nextElement());
        }

        return vProgramNames;
    }


    private ProgramHandler getProgramHandler(String sProgramName)
    {
        return (ProgramHandler)htProgramHandlers.get(sProgramName);
    }

    public void updateProgramMapping(String sProgramName, Vector vEventNames, Vector vEventSoundProperties)
    {
        ProgramHandler objPH = getProgramHandler(sProgramName);
        if(objPH!=null)
        {
            objPH.updateProgramMapping(vEventNames, vEventSoundProperties);

            RegisteredProgramsDB objRPDB = new RegisteredProgramsDB();
            objRPDB.storeProgramHandler(sProgramName,objPH);

        }
    }

    public void changeEventSoundMapping(String sProgramName, String sEventName, Vector vSoundProperties)
    {
        ProgramHandler objPH = getProgramHandler(sProgramName);
        if(objPH!=null)
        {
            objPH.changeEventSoundMapping(sEventName,vSoundProperties);

            RegisteredProgramsDB objRPDB = new RegisteredProgramsDB();
            objRPDB.storeProgramHandler(sProgramName,objPH);

        }


    }

    public Vector getSoundProperties(String sProgramName, String sEventName)
    {

        ProgramHandler objPH = getProgramHandler(sProgramName);
        if(objPH!=null)
        {
            System.out.println("Program Handler returned Sound Properties Successfully");
            return objPH.getSoundProperties(sEventName);
        }
        System.out.println("Program Handler did NOT return Sound Properties");
        return null;
    }

    public boolean isStatus()
    {
        return bStatus;
    }

    public void setStatus(boolean bStatus)
    {
        this.bStatus = bStatus;
    }



    public boolean registerProgram(String sProgramName, Hashtable htEventSoundHandler)
    {

        Enumeration objEnum = htEventSoundHandler.keys();
        Hashtable htESH=new Hashtable();

        while(objEnum.hasMoreElements())
        {
            //System.out.println("ESMAPPING____________________");
            //System.out.println("key   "+objEnum.nextElement());
            EventSoundMapping objESM = (EventSoundMapping) htEventSoundHandler.get(objEnum.nextElement());
            EventSoundHandler objESH=new EventSoundHandler(objESM.getEventName(), objESM.getSoundVariable(),objESM.getTime(), objESM.getNote());
            htESH.put(objESM.getEventName(), objESH);
        }

        ProgramHandler objPH= new ProgramHandler(sProgramName, htESH);
        this.htProgramHandlers.put(sProgramName, objPH);
        RegisteredProgramsDB objRDB=new RegisteredProgramsDB();
        objRDB.storeProgramHandler(sProgramName, objPH);
        objRDB.storeProgramNames(htProgramHandlers);
        return true;
    }

    public boolean unRegisterProgram(String sProgramName)
    {
        this.htProgramHandlers.remove(sProgramName);
        RegisteredProgramsDB objRDB=new RegisteredProgramsDB();
        objRDB.removeProgramHandler(sProgramName);
        objRDB.storeProgramNames(htProgramHandlers);
        return true;
    }

    public Vector getEventSoundHandlers(String sProgramName)
    {
        ProgramHandler objPH = getProgramHandler(sProgramName);


        if(objPH != null)
        {
                return objPH.getEvents();
        }

        return null;
    }

    public Vector getEventSoundMappings(String sProgramName)
    {
        ProgramHandler objPH = getProgramHandler(sProgramName);
        return objPH.getEvents();
    }
}

