package view;

import javax.swing.table.TableCellEditor;
import javax.swing.*;
import javax.swing.event.CellEditorListener;
import javax.swing.event.ChangeEvent;
import javax.swing.event.EventListenerList;
import java.awt.*;
import java.util.EventObject;

public class SoundCellEditor extends SoundCellRenderer implements TableCellEditor
{

    public Component getTableCellEditorComponent(JTable table, Object value,
                                                 boolean isSelected, int row,
                                                 int column)
    {
        return getTableCellRendererComponent(table, value, isSelected, true, row,
                column);
    }

    public void addCellEditorListener(CellEditorListener l)
    {
        listenerList.add(CellEditorListener.class, l);
    }

    public void removeCellEditorListener(CellEditorListener l)
    {
        listenerList.remove(CellEditorListener.class, l);
    }

    public boolean isCellEditable(EventObject anEvent)
    {
        return true;
    }

    public boolean shouldSelectCell(EventObject anEvent)
    {
        objSB.setVisible(true);
        return true;
    }

    public void cancelCellEditing()
    {
        objSB.setVisible(false);
    }

    public boolean stopCellEditing()
    {
        objSB.setVisible(false);
        return true;
    }

    public Object getCellEditorValue()
    {
        return objSB.getText();
    }

    protected void fireEditingStopped()
    {
        Object[] listeners = listenerList.getListenerList();
        for (int i = listeners.length - 2; i >= 0; i -= 2)
        {
            ((CellEditorListener) listeners[i + 1]).editingStopped(event);
        }
    }

    protected void fireEditingCanceled()
    {
        Object[] listeners = listenerList.getListenerList();
        for (int i = listeners.length - 2; i >= 0; i -= 2)
        {
            ((CellEditorListener) listeners[i + 1]).editingCanceled(event);
        }
    }

    private ChangeEvent event = new ChangeEvent(this);
    private EventListenerList listenerList = new EventListenerList();
}
